package com.danielyrovas.randomguessinggame;

import static android.content.ContentValues.TAG;

import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import java.util.Random;

public class MainActivity extends AppCompatActivity {
    private int ans;
    private TextView txtDisplay1;
    private TextView txtDisplay2;
    private EditText txtInput;
    private Button restartButton;
    private int guessCount;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Random random = new Random();
        ans = random.nextInt(20);
        Log.d(TAG, "onCreate: ans = " + ans);
        guessCount = 0;
        restartButton = findViewById(R.id.restartButton);
        restartButton.setVisibility(View.INVISIBLE);
        restartButton.setText("Restart");
        txtDisplay1 = findViewById(R.id.txtDisplay1);
        txtDisplay2 = findViewById(R.id.txtDisplay2);
        txtDisplay1.setText("Guess a number!");
        txtDisplay2.setText("");
        txtInput = findViewById(R.id.editTextNumber);
        txtInput.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView textView, int i, KeyEvent keyEvent) {
                switch (i) {
                    case EditorInfo.IME_ACTION_DONE:
                    case EditorInfo.IME_ACTION_NEXT:
                    case EditorInfo.IME_ACTION_PREVIOUS:
                        onGuessEnter();
                        return true;
                }
                return false;
            }
        });
    }

    public void onGuessEnter() {
        if (txtInput.getText().equals(null)) return;
        String guess = txtInput.getText().toString();
        if (guess.equals("")) {
            return;
        }
        txtInput.setText("");
        if (Integer.parseInt(guess) == ans) {
            txtDisplay2.setText("You guessed the correct number: " + guess);
            txtInput.setVisibility(View.INVISIBLE);
            restartButton.setVisibility(View.VISIBLE);
        } else {
            txtDisplay2.setText(guess + " is not the correct number");
        }
        guessCount++;
        if (guessCount >= 5) {
            txtDisplay2.setText("You are out of guesses!");
            txtInput.setVisibility(View.INVISIBLE);
            restartButton.setVisibility(View.VISIBLE);
        }
    }

    public void restartGame(View view) {
        txtInput.setVisibility(View.VISIBLE);
        restartButton.setVisibility(View.INVISIBLE);
        txtDisplay2.setText("");
        Random random = new Random();
        ans = random.nextInt(20);
        guessCount = 0;
    }
}